## joyent-mdata-client 0.0.1

=== Makefile ===

VERSION = 0.0.1

CC = gcc

CTFMERGE = /bin/true
CTFCONVERT = /bin/true

GNUTAR = tar

PWD := $(shell pwd)
UNAME_S := $(shell uname -s)
PLATFORM_OK = false

CFILES = dynstr.c proto.c common.c base64.c crc32.c reqid.c
OBJS = $(CFILES:%.c=%.o)
HDRS = dynstr.h plat.h proto.h common.h base64.h crc32.h reqid.h
CFLAGS = -I$(PWD) -Wall -Wextra -Werror -g -O2
LDLIBS =

BINDIR = /usr/sbin
MANSECT = 1m
MANDIR = /usr/share/man/man$(MANSECT)
DESTDIR = $(PWD)/proto

PROGS = \
	mdata-get \
	mdata-list \
	mdata-put \
	mdata-delete

PROTO_PROGS = \
	$(PROGS:%=$(DESTDIR)$(BINDIR)/%)

PROTO_MANPAGES = \
	$(PROGS:%=$(DESTDIR)$(MANDIR)/%.$(MANSECT))

INSTALL_TARGETS = \
	$(PROTO_PROGS) \
	$(PROTO_MANPAGES)

#
# Platform-specific definitions
#

ifeq ($(UNAME_S),SunOS)
CFLAGS += -D__HAVE_BOOLEAN_T
CFILES += plat/sunos.c plat/unix_common.c
HDRS += plat/unix_common.h
LDLIBS += -lnsl -lsocket -lsmbios
PLATFORM_OK = true
GNUTAR = gtar
endif

ifeq ($(UNAME_S),Linux)
CFILES += plat/linux.c plat/unix_common.c
HDRS += plat/unix_common.h
PLATFORM_OK = true
MANSECT = 1
INSTALL_TARGETS += $(DESTDIR)/lib/smartdc/mdata-get
PKGNAME = joyent-mdata-client
endif

ifeq ($(PLATFORM_OK),false)
$(error Unknown platform: $(UNAME_S))
endif

#
# Build Targets
#

.PHONY:	all world
world:	all
all:	$(PROGS)

%.o:	%.c
	$(CC) -c $(CFLAGS) -o $@ $<
	$(CTFCONVERT) -l mdata-client $@

mdata-%:	$(OBJS) $(HDRS) mdata_%.o
	$(CC) $(CFLAGS) $(LDLIBS) -o $@ $(@:mdata-%=mdata_%).o $(OBJS)
	$(CTFMERGE) -l mdata-client -o $@ $(OBJS) $(@:mdata-%=mdata_%).o

#
# Install Targets
#

.PHONY:	install
install:	$(INSTALL_TARGETS)

$(DESTDIR)$(BINDIR)/%: %
	@mkdir -p $(DESTDIR)$(BINDIR)
	cp $< $@
	touch $@

$(DESTDIR)$(MANDIR)/%.$(MANSECT): man/man1m/%.1m
	@mkdir -p $(DESTDIR)$(MANDIR)
	sed 's/__SECT__/$(MANSECT)/g' < $< > $@

$(DESTDIR)/lib/smartdc/mdata-%:
	@mkdir -p $$(dirname $@)
	@rm -f $@
	ln -s $(BINDIR)/$$(basename $@) $@

#
# SmartOS (smartos-live) Package Manifest Targets
#

.PHONY: manifest
manifest:
	cp manifest $(DESTDIR)/$(DESTNAME)

.PHONY: update
update:
	git pull --rebase

#
# Debian Package Targets
#
#

.PHONY: package-debian
package-debian:
	debuild -us -uc

source-tarball:
	if [ -z $(RELEASE_DIRECTORY) ]; then \
		echo "error: define RELEASE_DIRECTORY" >&2; \
		exit 1; \
	fi
	if [ -z $(PKGNAME) ]; then \
		echo "error: define PKGNAME" >&2; \
		exit 1; \
	fi
	$(GNUTAR) \
		-zc -f $(RELEASE_DIRECTORY)/$(PKGNAME)_$(VERSION).orig.tar.gz \
		--exclude=.git \
		--transform 's,^,$(PKGNAME)_$(VERSION)/,' \
		*

#
# Cleanup Targets
#

.PHONY:	clean
clean:
	rm -f $(PROGS) $(OBJS)

.PHONY:	clobber
clobber:	clean
	rm -rf $(PWD)/proto

=== debian/changelog ===
joyent-mdata-client (0.0.1-0ubuntu7) oracular; urgency=medium

  * d/p/respect-cflags.patch: add a patch to ensure the flags are properly
    propagated.
  * d/p/crc32-prototype-mismatch.patch: add a patch to fix prototype mismatch
    issues.

 -- Zixing Liu <zixing.liu@canonical.com>  Wed, 12 Jun 2024 11:19:18 -0600

joyent-mdata-client (0.0.1-0ubuntu6) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:00:39 +0200

joyent-mdata-client (0.0.1-0ubuntu5) jammy; urgency=high

  * No change rebuild for ppc64el baseline bump.

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 24 Mar 2022 13:05:17 +0100

joyent-mdata-client (0.0.1-0ubuntu4) impish; urgency=medium

  * No-change rebuild to build packages with zstd compression.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Oct 2021 12:13:30 +0200

joyent-mdata-client (0.0.1-0ubuntu3) artful; urgency=medium

  * No-change rebuild to pick up -fPIE compiler default in static
    libraries

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 21 Apr 2017 20:50:03 +0000

joyent-mdata-client (0.0.1-0ubuntu2) trusty; urgency=low

  * MIR feedback fixes (LP: #128000):
    - Removed secondary copyright on packaging
    - Fixed lintian message about duplicate homepage
    - Fixed capitalization of copyright 'EXPAT' to 'Expat' per dep5

 -- Ben Howard <ben.howard@ubuntu.com>  Fri, 08 Nov 2013 08:04:16 -0700

joyent-mdata-client (0.0.1-0ubuntu1) trusty; urgency=low

  * Initial release (LP: #1248000).

 -- Ben Howard <ben.howard@ubuntu.com>  Thu, 07 Nov 2013 08:14:52 -0700

=== debian/control ===
Source: joyent-mdata-client
Maintainer: Ben Howard <ben.howard@ubuntu.com>
Section: admin
Priority: optional
Standards-Version: 3.9.4
Build-Depends: debhelper (>= 8), devscripts
Homepage: https://github.com/joyent/mdata-client

Package: joyent-mdata-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: metadata client for use on SmartOS hyper-visor
 In-guest tools for interacting with the SmartOS hyper-visor datasource.
 These tools allows you to get, list and put key/value pairs with the
 SmartOS datasource.
